unit RIATCSMain;

{ *********************************************************** }
{  Rename Images according their Canvas Size                  }
{  Marian Stach, freeware, Presov, Slovakia, Central Europe   }
{  2003-10-26 - 2003-10-27                                    }
{                                                             }
{  Application will insert canvas size in pixels in front of  }
{  image file-name. Supported are all basic internet formats  }
{  (BMP, JPG, GIF, PNG), because I use it to scan Temporary   }
{  Internat Files directory.                                  }
{                                                             }
{  This application has been written during two long nights.  }
{  If you are learning to programm, this is definitelly not   }
{  an example to follow. It should be done in object form     }
{  with streams instead of buffered blocks.                   }
{ *********************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    CheckBox10: TCheckBox;
    Label3: TLabel;
    CheckBox11: TCheckBox;
    Edit4: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    CheckBox12: TCheckBox;
    Edit6: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    CheckBox13: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

const MaxBufSize = 2048;
type BufByte = array [ 0 .. MaxBufSize - 1 ] of Byte;

const bffBMP = 1000;
      bffGIF = bffBMP + 1;
      bffJPG = bffGIF + 1;
      bffPNG = bffJPG + 1;
      bffMNG = bffPNG + 1;
      bffJNG = bffMNG + 1;

var MainDir : string;
    //bufImg : BufByte;


procedure RenameAllFilesInDirectory (DirName, PFX : string);
procedure RenameAllImagesInDirectory (DirName : string);

function UpCaseStr (TStr : string) : string;
function PadZeros (TStr : string) : string;
function GetImageRatio (W, H : Integer) : Integer;
function GetNewPrefix (RealSize, MaxSize, L : Integer) : string;
function ParseWORD (B : BufByte; Offs : Integer; Motorola : Boolean) : Word;
function ParseDWORD (B : BufByte; Offs : Integer; Motorola : Boolean) : LongInt;
function GetOffset (S : string; Buf : BufByte; StartPos : Integer;
                    var OffsPos : Integer) : Boolean;

function IsAnimated (ImgType : Integer; ImgBuff : BufByte) : Boolean;
function CorrectImageFormat (InFN : string;
                             var ImgType : Integer;
                             var ImgBuff : BufByte) : Boolean;
function ImageSizeInLimits (ImgType : Integer; ImgBuff : BufByte;
                            var CanSize : Integer) : Boolean;




implementation

{$R *.dfm}

function UpCaseStr (TStr : string) : string;
    var i, L : Integer;
  begin
    L := Length (TStr);
    for i := 1 to L do TStr [ i ] := UpCase (TStr [ i ]);
    UpCaseStr  := TStr;
  end;

function PadZeros (TStr : string) : string;
    var i, L : Integer;
  begin
    L := Length (TStr);
    for i := 1 to L do
        if TStr [ i ] = ' ' then TStr [ i ] := '0';
    PadZeros := TStr;
  end;

function GetImageRatio (W, H : Integer) : Integer;
    var TReal : Real;
  begin
    TReal := W / H;
    if TReal < 1 then TReal := 1 / TReal;
    GetImageRatio := Trunc (TReal);
  end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if MainDir = '' then MainDir := GetCurrentDir;
  { if (Edit1.Text = '') then }
  if SelectDirectory ('Select directory to proceed',
                       ExtractFileDrive (GetCurrentDir), MainDir)
  //if SelectDirectory (MainDir, [sdAllowCreate, sdPerformCreate, sdPrompt], 0)
      then Edit1.Text := MainDir;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  if not CheckBox9.Checked then Edit2.Text := '0';
end;

procedure TForm1.Edit2Exit(Sender: TObject);
  var TReal : Real; TInt : Integer;
begin
  Val (Edit2.Text, TReal, TInt);
  if TReal <= 0 then begin Edit2.Text := '0'; CheckBox9.Checked := False; end
                else CheckBox9.Checked := True;
end;

procedure RenameAllFilesInDirectory (DirName, PFX : string);
    var S : TSearchRec; PFXL : Integer; TStr : string; PrCont : Boolean;
begin
  DirName := IncludeTrailingPathDelimiter (DirName);
  PrCont := ( FindFirst (DirName + '*.*', faAnyFile, S) = 0 );
  PFXL := Length (PFX);
  while PrCont do
        begin
          if (S.Attr <> faDirectory) and
             (S.Name <> '..') and (S.Name <> '.')
             then begin  { handling files }
                    if Form1.CheckBox13.Checked
                       then FileSetAttr (DirName + S.Name, faArchive);
                    TStr := Copy (S.Name, 1, PFXL);
                    if TStr = PFX then
                       begin
                         TStr := Copy (S.Name, PFXL + 1, 255);
                         TStr := Copy (TStr, Pos ('_', TStr) + 1, 255);
                         RenameFile (DirName + S.Name, DirName + TStr);
                         { RenameFile is function - returns False when fails }
                       end;
                  end
             else      { checking if it is really directory }
               if Form1.CheckBox1.Checked and (S.Attr = faDirectory) and
                  (S.Name <> '..') and (S.Name <> '.') { cannot go up !!! }
                  then { recurssive call }
                    RenameAllFilesInDirectory (DirName + S.Name + '\', PFX);
          PrCont := ( FindNext (S) = 0 );
        end;  { while Process Continue }
end;

procedure TForm1.Button3Click(Sender: TObject);
  { Restoration of original file-names:                                    }
  { Whole directory is scanned and all filenames are checked. If it starts }
  { with the string specified as prefix, the second '_' is localized and   }
  { the rest is taken as original file name.                               }
begin
  //MainDir := Edit1.Text;
  RenameAllFilesInDirectory (Edit1.Text, Edit5.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  //MainDir := Edit1.Text;
  RenameAllImagesInDirectory (Edit1.Text);
end;

procedure RenameAllImagesInDirectory (DirName : string);
    var S : TSearchRec; PrCont : Boolean;
        TInt, LimFS, LimCS, LLimCS, bffImg, bffCanvasSize : Integer;
        TStr : string; bufImg : BufByte;
  begin
    Val (Form1.Edit2.Text, LimFS, TInt); LimFS := LimFS * 1024;
    Val (Form1.Edit6.Text, LimCS, TInt); LimCS := LimCS * 1024;
    if Form1.CheckBox12.Checked then LimCS := LimCS * 1024;
    Str (LimCS, TStr); LLimCS := Length (TStr);
    DirName := IncludeTrailingPathDelimiter (DirName);

    PrCont := ( FindFirst (DirName + '*.*', faAnyFile, S) = 0 );
    while PrCont do
          begin
            if (S.Attr <> faDirectory) and
               (S.Name <> '..') and (S.Name <> '.')
               then begin  { handling files }

       if Form1.CheckBox13.Checked
          then FileSetAttr (DirName + S.Name, faArchive);
       if Form1.CheckBox9.Checked and (S.Size >= LimFS) and
          (Pos (Form1.Edit5.Text, S.Name) = 0) then
          //to avoid multi-run because by Rename we changing dir content!!!
             { both by extenssion and by header }
          if CorrectImageFormat (DirName + S.Name, bffImg, bufImg) then
             if ImageSizeInLimits (bffImg, bufImg, bffCanvasSize) then
                begin
                  TStr := GetNewPrefix (bffCanvasSize, LimCS, LLimCS);
                  if Form1.CheckBox7.Checked and
                     ( (bffImg = bffGIF) or (bffImg = bffMNG) ) then
                     if IsAnimated (bffImg, bufImg) then TStr := TStr + 'A'
                                                    else TStr := TStr + 'S';
                  RenameFile (DirName + S.Name,
                              DirName + Form1.Edit5.Text + TStr + '_' + S.Name)
                end;

                    end
               else      { checking if it is really directory }
                 if Form1.CheckBox1.Checked and (S.Attr = faDirectory) and
                    (S.Name <> '..') and (S.Name <> '.') { cannot go up !!! }
                    then { recurssive call }
                      RenameAllImagesInDirectory (DirName + S.Name + '\');
          PrCont := ( FindNext (S) = 0 );
        end;  { while Process Continue }
  end;

function GetNewPrefix (RealSize, MaxSize, L : Integer) : string;
    var TStr : string;
  begin
    if Form1.CheckBox12.Checked then RealSize := MaxSize - RealSize;
    if RealSize < 0 then RealSize := 0;
    Str (RealSize : L, TStr);
    TStr := PadZeros (TStr);
    GetNewPrefix := TStr;
  end;

function CorrectImageFormat (InFN : string;
                             var ImgType : Integer;
                             var ImgBuff : BufByte) : Boolean;
    var TInt : Integer; TStr : string;
        fImg : file of Byte;
  begin
{******************************************************************************}
{ GIF: Starts with 'GIF87a' or 'GIF89a' and finish usually with 003Bh }
{ BMP: Starts with 'BM' followed by DWORD - Intel of file size }
{ PNG, MNG, JNG }
    ImgType := 0;
    if not Form1.CheckBox6.Checked then
       begin
              TStr := UpCaseStr (InFN);
              if ( Pos ('.BMP', TStr) <> 0 ) or
                 ( Pos ('.RLE', TSTr) <> 0 ) or
                 ( Pos ('.DIB', TStr) <> 0 ) or
                 ( Pos ('.LGO', TStr) <> 0 ) then ImgType := bffBMP
              else if Pos ('.GIF', TStr) <> 0 then ImgType := bffGIF
              else if ( Pos ('.JPG', TStr) <> 0 ) or
                      ( Pos ('.JPE', TStr) <> 0 ) or
                      ( Pos ('.JPEG', TStr) <> 0 ) or  //this one will never
                      ( Pos ('.JFF', TStr) <> 0 ) or
                      ( Pos ('.JFI', TStr) <> 0 ) or   //this too
                      ( Pos ('.JFIF', TStr) <> 0 ) then ImgType := bffJPG
              else if Pos ('.PNG', TStr) <> 0 then ImgType := bffPNG
              else if Pos ('.MNG', TStr) <> 0 then ImgType := bffMNG
              else if Pos ('.JNG', TStr) <> 0 then ImgType := bffJNG;
       end;
    if (ImgType <> 0) or Form1.CheckBox6.Checked then
       begin
         AssignFile (fImg, InFN);
         ReSet (fImg);
         BlockRead (fImg, ImgBuff, MaxBufSize, TInt);  //could be problems here
         TInt := FileSize (fImg) mod 256;              //just one byte for BMP
         CloseFile (fImg);

      if ImgType = 0 then
         if GetOffset ('BM', ImgBuff, 0, TInt) and (TInt = 0)
            then ImgType := bffBMP
         else if GetOffset ('GIF8', ImgBuff, 0, TInt) and (TInt = 0)
                 then ImgType := bffGIF
         else if GetOffset (Chr ($FF) + Chr ($D8) + Chr ($FF),
                            ImgBuff, 0, TInt) and (TInt = 0)
                 then ImgType := bffJPG
         else if GetOffset (Chr ($89) + 'PNG' + Chr ($0D) + Chr ($0A)
                            + Chr ($1A) + Chr ($0A), ImgBuff, 0, TInt)
                   and (TInt = 0)
                 then ImgType := bffPNG
         else if GetOffset (Chr ($8A) + 'MNG' + CHr ($0D) + CHr ($0A)
                            + Chr ($1A) + Chr ($0A), ImgBuff, 0, TInt)
                   and (TInt = 0)
                 then ImgType := bffMNG
         else if GetOffset (Chr ($8B) + 'JNG' + CHr ($0D) + CHr ($0A)
                            + CHr ($1A) + CHr ($0A), ImgBuff, 0, TInt)
                   and (TInt = 0)
                 then ImgType := bffJNG;
       end;
    CorrectImageFormat := (ImgType <> 0);
  end;

function ParseWORD (B : BufByte; Offs : Integer; Motorola : Boolean) : Word;
{ Motorola use highest byte first, so value is normally readable. }
{ E.g. 800 is 320h, so it will be written as 03 20 in Motorola    }
{ and 20 03 for Intel.                                            }
    var TW : Word;
  begin
    if Motorola then TW := 256 * B [ Offs ] + B [ Offs + 1 ]
                else TW := 256 * B [ Offs + 1 ] + B [ Offs ];
    ParseWORD := TW;
  end;

function ParseDWORD (B : BufByte; Offs : Integer; Motorola : Boolean) : LongInt;
    var TLI : LongInt;
  begin
    if Motorola
       then TLI := 256 * 256 * 256 * B [ Offs ] + 256 * 256 * B [ Offs + 1 ] +
                   256 * B [ Offs + 2 ] + B [ Offs + 3 ]
       else TLI := 256 * 256 * 256 * B [ Offs + 3 ] +
                   256 * 256 * B [ Offs + 2 ] + 256 * B [ Offs + 1 ] +
                   B [ Offs + 3 ];
    ParseDWORD := TLI;
  end;

function ImageSizeInLimits (ImgType : Integer; ImgBuff : BufByte;
                            var CanSize : Integer) : Boolean;
    var W, H : LongInt; TBool : Boolean;
        LS, LR, TInt : Integer;
  begin
    CanSize := 0;
    Val (Form1.Edit3.Text, LS, TInt); Val (Form1.Edit4.Text, LR, TInt);
    case ImgType of
         bffBMP : begin
                    W := ParseDWORD (ImgBuff, 18, False);
                    H := ParseDWORD (ImgBuff, 22, False);
                  end;
         bffGIF : begin
                    W := ParseWORD (ImgBuff, 6, False);
                    H := ParseWORD (ImgBuff, 8, False);
                  end;
         bffJPG : begin
                    GetOffset (Chr ($FF) + Chr ($C0), ImgBuff, 0, TInt);
                    if TInt = 0
                       then GetOffset (Chr ($FF) + Chr ($C1), ImgBuff, 0, TInt);
                    W := ParseWORD (ImgBuff, TInt + 7, True);
                    H := ParseWORD (ImgBuff, TInt + 5, True);
                  end;
         bffPNG : begin
                    GetOffset ('IHDR', ImgBuff, 0, TInt);
                    W := ParseDWORD (ImgBuff, TInt + 4, True);
                    H := ParseDWORD (ImgBuff, TInt + 8, True);
                  end;
         bffMNG : begin
                    GetOffset ('MHDR', ImgBuff, 0, TInt);
                    W := ParseDWORD (ImgBuff, TInt + 4, True);
                    H := ParseDWORD (ImgBuff, TInt + 8, True);
                  end;
         bffJNG : begin
                    GetOffset ('JHDR', ImgBuff, 0, TInt);
                    W := ParseDWORD (ImgBuff, TInt + 4, True);
                    H := ParseDWORD (ImgBuff, TInt + 8, True);
                  end
         else begin W := 0; H := 0; end;
    end;
    CanSize := W * H;
    TBool := (CanSize <> 0);
    if Form1.CheckBox10.Checked then
       TBool := TBool and ( (W >= LS) and (H >= LS) );
    if Form1.CheckBox11.Checked then
       TBool := TBool and ( GetImageRatio (W, H) <= LR );
    ImageSizeInLimits := TBool;
  end;

function IsAnimated (ImgType : Integer; ImgBuff : BufByte) : Boolean;
    var TBool : Boolean; TInt : Integer;
  begin
    TBool := False;
    if ImgType = bffMNG then TBool := True
       else begin { only bffGIF can be here }
{ Graphics Extension block starts only with 21F9h. To avoid any              }
{ misinterpretation we will look for 21F904h, because this block has fixed   }
{ length. We have good chance we will not be wrong                           }
              if GetOffset (Chr ($21) + Chr ($F9) + Chr ($04), ImgBuff, 0, TInt)
                 and                              { graphic ext.? + its length }
                 ( ((ImgBuff [ TInt + 3 ] and 2) <> 0) or {user action required}
                   (ImgBuff [ TInt + 4 ] <> 0) or      { low byte - delay time }
                   (ImgBuff [ TInt + 5 ] <> 0) )      { high byte - delay time }
                 then TBool := True;
            end;
    IsAnimated := TBool;
  end;

function GetOffset (S : string; Buf : BufByte; StartPos : Integer;
                    var OffsPos : Integer) : Boolean;
{ Will scan buffer for possition of given sub-string. The same can be done  }
{ using null-terminated strings, however it can confuse when translating    }
{ into other languages or platforms. It will start from StartPos, just for  }
{ cases when we need to scan not from beggining.                            }
    var i, L : Integer; TStr : string; Found : Boolean;
  begin
    L := Length (S);
    for i := 1 to L do TStr := TStr + Chr (Buf [ StartPos + i - 1 ]);
    OffsPos := StartPos;
    Found := (S = TStr);
    i := StartPos + L - 1;
    while (not Found) and (i < (MaxBufSize - L)) do
          begin
            Inc (i);
            Inc (OffsPos);
            TStr := Copy (TStr, 2, 255) + Chr (Buf [ i ]);
            Found := (S = TStr);
          end;
    GetOffset := Found;
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button2.Enabled := False;
  Button3.Enabled := False;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if Edit1.Text <> '' then
     begin
       Button2.Enabled := True; Button3.Enabled := True;
     end
     else begin
            Button2.Enabled := False; Button3.Enabled := False;
          end;
end;

end.
